<?php
/* Copyright start
  Copyright (C) 2008 - 2022 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace App\Service;

class TokenHelper
{

    public function extractThreatFeedTokens(String $value)
    {
        if (is_null($value)) {
            return '{}';
        }
        $tokens = '{' . $this->escapeSpecialChars($value);
        // extract domain if it's a URL
        preg_match('#.*\://?([^\/]+)#', $value, $domainMatches);
        if (!is_null($domainMatches) && sizeof($domainMatches) > 0) {
            $tokens = $tokens . "," . $this->escapeSpecialChars($domainMatches[1]);
        }
        // extract IP if network activity
        preg_match('#([0-9]*\.[0-9]*\.[0-9]*\.[0-9]*)\:[0-9]*#', $value, $ipMatches);
        if (!is_null($ipMatches) && sizeof($ipMatches) > 0) {
            $tokens =  $tokens . "," . $this->escapeSpecialChars($ipMatches[1]);
        }
        $tokens = $tokens . '}';
        return $tokens;
    }

    private function escapeSpecialChars(String $value)
    {   
        // removing everything except alphanumeric (all supported locale),hyphen,dot,colon and space
        return preg_replace("/[^[:alnum:][:space:]:\.\-]/u", "", $value);
    }
}
